﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Infragistics.Web.Mvc;
using HierarchicalCRUD.Models;

namespace HierarchicalCRUD.Controllers
{
    public class HomeController : Controller
    {
		GridViewModel model = new GridViewModel();
		//
        // GET: /Home/

        public ActionResult Index()
        {
			return View(model);
        }

		public JsonResult BindProduct(string path, string layout)
		{
			string categoryID = path.Split(':')[1];
			return Json(model.Products.Where(p => p.CategoryID == int.Parse(categoryID)), JsonRequestBehavior.AllowGet);
		}

		public ActionResult CategoryUpdatingSaveChanges()
		{
			GridModel m = new GridModel();
			List<Transaction<HierarchicalCRUD.Models.Category>> transactions = m.LoadTransactions<HierarchicalCRUD.Models.Category>(HttpContext.Request.Form["ig_transactions"]);
			Dictionary<string, object> response = new Dictionary<string, object>();

			foreach (Transaction<HierarchicalCRUD.Models.Category> trans in transactions)
			{
				if (trans.type == "newrow")
				{
					model.Categories.ToList().Add(trans.row);
				}
				else if (trans.type == "deleterow")
				{
				}
				else if (trans.type == "row")
				{
				}
			}

			JsonResult result = new JsonResult();
			response.Add("Success", true);

			result.Data = response;
			return result;
		}

		public ActionResult ProductUpdatingSaveChanges()
		{
			GridModel m = new GridModel();
			List<Transaction<HierarchicalCRUD.Models.Product>> transactions = m.LoadTransactions<HierarchicalCRUD.Models.Product>(HttpContext.Request.Form["ig_transactions"]);
			Dictionary<string, object> response = new Dictionary<string, object>();

			foreach (Transaction<HierarchicalCRUD.Models.Product> trans in transactions)
			{
				if (trans.type == "newrow")
				{
					model.Products.ToList().Add(trans.row);
				}
				else if (trans.type == "deleterow")
				{
				}
				else if (trans.type == "row")
				{
				}
			}

			JsonResult result = new JsonResult();
			response.Add("Success", true);

			result.Data = response;
			return result;
		}
    }
}
